diff --git a/app/fin/task/billing_apportion_task.go b/app/fin/task/billing_apportion_task.go
index e43c09043af05cc52a5e2d19d392ad633fc18314..4d31f3ec9069b803fb68311301e568a042d2c27d 100644
--- a/app/fin/task/billing_apportion_task.go
+++ b/app/fin/task/billing_apportion_task.go
@@ -31,6 +31,7 @@ type ApportionTaskServer struct {
 	srvPayment         finSvr.IFinPaymentService
 	srvRecord          finSvr.IFinDeviceRecordService
 	srvScheme          finSvr.IFinApportionSchemesService
+	srvElectric        finSvr.IFinSharedElectricService
 	srvSharedCommon    *SharedCommon
 }
 
@@ -77,38 +78,43 @@ func NewApportionTaskServer() *ApportionTaskServer {
 	}); err != nil {
 		panic(err)
 	}
+	if err := core.GetContainer().Invoke(func(s finSvr.IFinSharedElectricService) {
+		server.srvElectric = s
+	}); err != nil {
+		panic(err)
+	}
 	server.srvSharedCommon = NewSharedCommon()
 
 	return server
 }
 
 // 启动定时任务
-func (apportion *ApportionTaskServer) Start(cron string) {
-	_, err := apportion.taskCron.AddFunc(cron, apportion.calcElectricFee)
+func (task *ApportionTaskServer) Start(cron string) {
+	_, err := task.taskCron.AddFunc(cron, task.calcElectricFee)
 	if err != nil {
 		fmt.Println("Add Billing Task error:{}", err)
 		return
 	}
-	_, err = apportion.taskCron.AddFunc(cron, apportion.calcWaterFee)
+	_, err = task.taskCron.AddFunc(cron, task.calcWaterFee)
 	if err != nil {
 		fmt.Println("Add Billing Task error:{}", err)
 		return
 	}
-	_, err = apportion.taskCron.AddFunc(cron, apportion.calcGasFee)
+	_, err = task.taskCron.AddFunc(cron, task.calcGasFee)
 	if err != nil {
 		fmt.Println("Add Billing Task error:{}", err)
 		return
 	}
-	apportion.taskCron.Start()
+	task.taskCron.Start()
 }
 
 // 停止定时任务
-func (apportion *ApportionTaskServer) Stop() {
-	apportion.taskCron.Stop()
+func (task *ApportionTaskServer) Stop() {
+	task.taskCron.Stop()
 }
 
 // 计算电力分摊费用
-func (apportion *ApportionTaskServer) calcElectricFee() {
+func (task *ApportionTaskServer) calcElectricFee() {
 	core.TryLock(constants.Lock_key_AElectric, "1", 5*time.Minute)
 	defer core.UnLock(constants.Lock_key_AElectric)
 
@@ -116,11 +122,11 @@ func (apportion *ApportionTaskServer) calcElectricFee() {
 	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
 	startDay := endDay.AddDate(0, -1, 0)
 	endDay = time.Date(endDay.Year(), endDay.Month(), 1, 0, 0, 0, 0, now.Location())
-	apportion.calcFeeAuto("electric", constants.BillTypeEnum.AElectric, startDay, endDay)
+	task.calcFeeAuto("electric", constants.BillTypeEnum.AElectric, startDay, endDay)
 }
 
 // 计算电力分摊费用
-func (apportion *ApportionTaskServer) calcWaterFee() {
+func (task *ApportionTaskServer) calcWaterFee() {
 	core.TryLock(constants.Lock_key_AWater, "1", 5*time.Minute)
 	defer core.UnLock(constants.Lock_key_AWater)
 
@@ -128,11 +134,11 @@ func (apportion *ApportionTaskServer) calcWaterFee() {
 	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
 	startDay := endDay.AddDate(0, -1, 0)
 	endDay = time.Date(endDay.Year(), endDay.Month(), 1, 0, 0, 0, 0, now.Location())
-	apportion.calcFeeAuto("water", constants.BillTypeEnum.AWater, startDay, endDay)
+	task.calcFeeAuto("water", constants.BillTypeEnum.AWater, startDay, endDay)
 }
 
 // 计算电力分摊费用
-func (apportion *ApportionTaskServer) calcGasFee() {
+func (task *ApportionTaskServer) calcGasFee() {
 	core.TryLock(constants.Lock_key_AGas, "1", 5*time.Minute)
 	defer core.UnLock(constants.Lock_key_AGas)
 
@@ -140,7 +146,7 @@ func (apportion *ApportionTaskServer) calcGasFee() {
 	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
 	startDay := endDay.AddDate(0, -1, 0)
 	endDay = time.Date(endDay.Year(), endDay.Month(), 1, 0, 0, 0, 0, now.Location())
-	apportion.calcFeeAuto("gas", constants.BillTypeEnum.AGas, startDay, endDay)
+	task.calcFeeAuto("gas", constants.BillTypeEnum.AGas, startDay, endDay)
 }
 
 // 计算电力分摊费用
@@ -152,7 +158,7 @@ func (task *ApportionTaskServer) calcFeeManual(houseIds []uint, ownerId uint,
 	if err != nil || len(ownerList) <= 0 {
 		record := finReq.FinBillManulErrResp{
 			RetCode: "101",
-			RetDesc: "该房间无分摊业主",
+			RetDesc: "该房间无分摊方案",
 		}
 		rets = append(rets, record)
 		return rets
@@ -171,7 +177,7 @@ func (task *ApportionTaskServer) calcFeeManual(houseIds []uint, ownerId uint,
 		}
 		devSchemeMap[key] = scheme
 	}
-	dataRecords, err := task.srvRecord.ListByHouseIds(nil, deviceIds, constants.BillTypeEnum.SElectric, startDay, endDay)
+	dataRecords, err := task.srvRecord.ListByHouseIds(nil, nil, deviceIds, constants.BillTypeEnum.SElectric, true, startDay, endDay)
 	if err != nil || len(dataRecords) <= 0 {
 		var cond finReq.FinCommonDeviceReq
 		cond.HouseIds = houseIds
@@ -179,7 +185,7 @@ func (task *ApportionTaskServer) calcFeeManual(houseIds []uint, ownerId uint,
 		if err != nil || len(houses) <= 0 {
 			record := finReq.FinBillManulErrResp{
 				RetCode: "101",
-				RetDesc: "无设备",
+				RetDesc: "无关联设备",
 			}
 			return append(rets, record)
 		}
@@ -219,7 +225,10 @@ func (task *ApportionTaskServer) calcFeeManual(houseIds []uint, ownerId uint,
 	}
 	for _, manual := range manualMap {
 		key := strconv.FormatUint(uint64(manual.HouseId), 10) + ":" + strconv.FormatUint(uint64(manual.DeviceId), 10)
-		scheme, _ := devSchemeMap[key]
+		scheme, find := devSchemeMap[key]
+		if !find {
+			continue
+		}
 		var arr []finReq.FinBillManulResp
 		switch scheme.SharedMethod {
 		case "area":
@@ -260,7 +269,7 @@ func (task *ApportionTaskServer) calcFeeAuto(schemeType string, billType string,
 		}
 		devSchemeMap[key] = scheme
 	}
-	dataRecords, err := task.srvRecord.ListByHouseIds(nil, deviceIds, constants.BillTypeEnum.SElectric, startDay, endDay)
+	dataRecords, err := task.srvRecord.ListByHouseIds(nil, nil, deviceIds, constants.BillTypeEnum.SElectric, true, startDay, endDay)
 	if err != nil || len(dataRecords) <= 0 {
 		return err
 	}
diff --git a/app/fin/task/billing_ecs_task.go b/app/fin/task/billing_ecs_task.go
index ff410b01310e73100c2fc3a2d892d365d6d81d24..ebc4dd8faa5203e0ad6dafa08cb2af61913e70f0 100644
--- a/app/fin/task/billing_ecs_task.go
+++ b/app/fin/task/billing_ecs_task.go
@@ -1,6 +1,7 @@
 package task
 
 import (
+	"encoding/json"
 	"errors"
 	"fmt"
 	"math"
@@ -205,6 +206,29 @@ func (task *EcsTaskServer) calcFee() {
 				default:
 					break
 				}
+				stepFee := ""
+				if scheme.BillingMethod == "4" || scheme.BillingMethod == "5" {
+					stepItemMap := make(map[int]finReq.SchemeStepItem)
+					for _, scheme := range schemeTimes {
+						item, find := stepItemMap[scheme.seq]
+						if !find {
+							item.Seq = scheme.seq
+							item.BillAmmount = 0
+							item.UsageTotal = 0
+						}
+						item.BillAmmount += scheme.billAmmount
+						item.UsageTotal += scheme.usageTotal
+						stepItemMap[scheme.seq] = item
+					}
+					var stepFeeList []finReq.SchemeStepItem
+					for _, scheme := range stepItemMap {
+						stepFeeList = append(stepFeeList, scheme)
+					}
+					tmpFee, err := json.Marshal(stepFeeList)
+					if err == nil {
+						stepFee = string(tmpFee)
+					}
+				}
 				actionReq, find := houseFeeMap[houseId]
 				if !find {
 					actionReq.DeviceId = device.DeviceId
@@ -213,48 +237,50 @@ func (task *EcsTaskServer) calcFee() {
 				houseFeeMap[houseId] = actionReq
 
 				bill := finModel.FinBill{
-					BillType:   billType,
-					RegionId:   device.RegionId,
-					RegionName: device.RegionName,
-					AreaId:     device.AreaId,
-					AreaName:   device.AreaName,
-					HouseId:    houseId,
-					HouseName:  houseName,
-					DeviceId:   device.DeviceId,
-					DeviceName: device.DeviceName,
-					StartDate:  startDay,
-					EndDate:    endDay,
-					BillAmount: math.Round(billAmount*100) / 100,
-					UsageStart: math.Round(totalUsageStart*100) / 100,
-					UsageEnd:   math.Round(totalUsageEnd*100) / 100,
-					UsageTotal: math.Round(usageTotal*100) / 100,
-					TenantId:   scheme.TenantId,
-					FinTime:    finTime,
-					EcsTime:    endDay,
+					BillType:      billType,
+					RegionId:      device.RegionId,
+					RegionName:    device.RegionName,
+					AreaId:        device.AreaId,
+					AreaName:      device.AreaName,
+					HouseId:       houseId,
+					HouseName:     houseName,
+					DeviceId:      device.DeviceId,
+					DeviceName:    device.DeviceName,
+					StartDate:     startDay,
+					EndDate:       endDay,
+					BillAmount:    math.Round(billAmount*100) / 100,
+					UsageStart:    math.Round(totalUsageStart*100) / 100,
+					UsageEnd:      math.Round(totalUsageEnd*100) / 100,
+					UsageTotal:    math.Round(usageTotal*100) / 100,
+					TenantId:      scheme.TenantId,
+					FinTime:       finTime,
+					EcsTime:       endDay,
+					BillingMethod: scheme.BillingMethod,
+					StepFee:       stepFee,
 				}
 				bill.CreateTime = createTime
 				billRecords = append(billRecords, bill)
-				record := finModel.FinPayment{
-					BillType:   billType,
-					RegionId:   device.RegionId,
-					RegionName: device.RegionName,
-					AreaId:     device.AreaId,
-					AreaName:   device.AreaName,
-					HouseId:    houseId,
-					HouseName:  houseName,
-					DeviceId:   device.DeviceId,
-					DeviceName: device.DeviceName,
-					StartDate:  startDay,
-					EndDate:    endDay,
-					BillAmount: math.Round(billAmount*100) / 100,
-					UsageStart: math.Round(totalUsageStart*100) / 100,
-					UsageEnd:   math.Round(totalUsageEnd*100) / 100,
-					UsageTotal: math.Round(usageTotal*100) / 100,
-					TenantId:   scheme.TenantId,
-					FinTime:    finTime,
-				}
-				record.CreateTime = createTime
-				records = append(records, record)
+				// record := finModel.FinPayment{
+				// 	BillType:   billType,
+				// 	RegionId:   device.RegionId,
+				// 	RegionName: device.RegionName,
+				// 	AreaId:     device.AreaId,
+				// 	AreaName:   device.AreaName,
+				// 	HouseId:    houseId,
+				// 	HouseName:  houseName,
+				// 	DeviceId:   device.DeviceId,
+				// 	DeviceName: device.DeviceName,
+				// 	StartDate:  startDay,
+				// 	EndDate:    endDay,
+				// 	BillAmount: math.Round(billAmount*100) / 100,
+				// 	UsageStart: math.Round(totalUsageStart*100) / 100,
+				// 	UsageEnd:   math.Round(totalUsageEnd*100) / 100,
+				// 	UsageTotal: math.Round(usageTotal*100) / 100,
+				// 	TenantId:   scheme.TenantId,
+				// 	FinTime:    finTime,
+				// }
+				// record.CreateTime = createTime
+				// records = append(records, record)
 			}
 		}
 		if scheme.FeeAction == "1" {
@@ -329,9 +355,6 @@ func (task *EcsTaskServer) calcFeeManual(billType string, houseIds []uint, owner
 	}
 	for _, scheme := range lists {
 		// 查询符合条件设备
-		var cond finReq.FinEcsDeviceListReq
-		cond.SchemeId = scheme.Id
-		cond.HouseIds = houseIds
 		houseToDeviceMap := make(map[uint][]finReq.FinEcsSchemeDeviceResp)
 		deviceList, _ := task.srvEcsDev.ListSchemeValidDevice(scheme.Id, 0, ownerId, 0, houseIds, "")
 		if len(deviceList) <= 0 {
@@ -446,28 +469,54 @@ func (task *EcsTaskServer) calcFeeManual(billType string, houseIds []uint, owner
 				default:
 					break
 				}
+				stepFee := ""
+				if scheme.BillingMethod == "4" || scheme.BillingMethod == "5" {
+					stepItemMap := make(map[int]finReq.SchemeStepItem)
+					for _, scheme := range schemeTimes {
+						item, find := stepItemMap[scheme.seq]
+						if !find {
+							item.Seq = scheme.seq
+							item.BillAmmount = 0
+							item.UsageTotal = 0
+						}
+						item.BillAmmount += scheme.billAmmount
+						item.UsageTotal += scheme.usageTotal
+						stepItemMap[scheme.seq] = item
+					}
+					var stepFeeList []finReq.SchemeStepItem
+					for _, scheme := range stepItemMap {
+						stepFeeList = append(stepFeeList, scheme)
+					}
+					tmpFee, err := json.Marshal(stepFeeList)
+					if err == nil {
+						stepFee = string(tmpFee)
+					}
+				}
+
 				record := finReq.FinBillManulResp{
-					BillType:   billType,
-					RegionId:   device.RegionId,
-					RegionName: device.RegionName,
-					AreaId:     device.AreaId,
-					AreaName:   device.AreaName,
-					HouseId:    houseId,
-					HouseName:  houseName,
-					HouseArea:  houseArea,
-					DeviceId:   device.DeviceId,
-					DeviceName: device.DeviceName,
-					Address:    device.Address,
-					MeterType:  device.MeterType,
-					StartDate:  startDay,
-					EndDate:    endDay,
-					FeeName:    feeName,
-					BillAmount: math.Round(billAmount*100) / 100,
-					UsageStart: math.Round(totalUsageStart*100) / 100,
-					UsageEnd:   math.Round(totalUsageEnd*100) / 100,
-					UsageTotal: math.Round(usageTotal*100) / 100,
-					FinTime:    finTime,
-					RetCode:    "200",
+					BillType:      billType,
+					RegionId:      device.RegionId,
+					RegionName:    device.RegionName,
+					AreaId:        device.AreaId,
+					AreaName:      device.AreaName,
+					HouseId:       houseId,
+					HouseName:     houseName,
+					HouseArea:     houseArea,
+					DeviceId:      device.DeviceId,
+					DeviceName:    device.DeviceName,
+					Address:       device.Address,
+					MeterType:     device.MeterType,
+					StartDate:     startDay,
+					EndDate:       endDay,
+					FeeName:       feeName,
+					BillAmount:    math.Round(billAmount*100) / 100,
+					UsageStart:    math.Round(totalUsageStart*100) / 100,
+					UsageEnd:      math.Round(totalUsageEnd*100) / 100,
+					UsageTotal:    math.Round(usageTotal*100) / 100,
+					FinTime:       finTime,
+					RetCode:       "200",
+					BillingMethod: scheme.BillingMethod,
+					StepFee:       stepFee,
 				}
 				records = append(records, record)
 			}
@@ -554,6 +603,7 @@ func (task *EcsTaskServer) calcStepFee(schemeId uint, schemeTimes []*SchemeTime)
 			price := item.(float64)
 			ammount += usageTotal * price
 		}
+		schemeTime.billAmmount = ammount
 	}
 	return ammount
 }
diff --git a/app/fin/task/billing_shared_att_task.go b/app/fin/task/billing_shared_att_task.go
index eeab502fcbcf5dc8fe78b501d86c4e1591a549d6..45ee523bb9daeb3717e5b45ed55327307eb06312 100644
--- a/app/fin/task/billing_shared_att_task.go
+++ b/app/fin/task/billing_shared_att_task.go
@@ -1,8 +1,6 @@
 package task
 
 import (
-	"strconv"
-	"strings"
 	"time"
 
 	devSvr "energy-server-mgo/app/admin/service/device"
@@ -81,32 +79,27 @@ func (task *SharedAttTask) calcFee() {
 	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
 	startDay := endDay.AddDate(0, 0, -1)
 
+	deviceTypes := []string{}
 	var cond finReq.FinSharedListReq
 	lists, _ := task.srvAtt.ListAll(cond)
 	for _, scheme := range lists {
 		var areaIds []uint
-		for _, val := range strings.Split(scheme.AreaIds, ",") {
-			tmpId, err := strconv.ParseUint(val, 10, 64)
-			if err != nil {
-				continue
-			}
-			areaIds = append(areaIds, uint(tmpId))
-		}
-		houseList, err := task.srvCommon.ListCommonAreaHouse(areaIds, nil)
-		if err != nil {
+		areaIds = append(areaIds, scheme.CommonAreaId)
+		deviceList, _ := task.srvCommon.ListCommonAreaDevice(areaIds, deviceTypes)
+		if len(deviceList) <= 0 {
 			continue
 		}
 		var deviceRecords []finModel.FinDeviceRecord
 		billAmount := float64(scheme.Price[0].(float64))
 		switch scheme.ApportionMethod {
 		case "0":
-			deviceRecords = task.srvSharedCommon.calcAttSquareFee(houseList, scheme.SquareType, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(deviceRecords, deviceTypes, scheme.MigrDate, startDay, scheme.SquareType, billAmount)
 			break
 		case "1":
-			deviceRecords = task.srvSharedCommon.calcAttHouseFee(houseList, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(deviceRecords, deviceTypes, scheme.MigrDate, startDay, billAmount)
 			break
 		case "2":
-			deviceRecords = task.srvSharedCommon.calcAttSelfFee(houseList, scheme.Price, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(deviceRecords, deviceTypes, scheme.MigrDate, scheme.Price, startDay, endDay, billAmount)
 			break
 		}
 		for idx, record := range deviceRecords {
diff --git a/app/fin/task/billing_shared_common.go b/app/fin/task/billing_shared_common.go
index fbb7af198393dfe7759ec538febd3ffd6ad8dc56..2d33fd6017d158590c2ff10e88c342b53bd7e0ab 100644
--- a/app/fin/task/billing_shared_common.go
+++ b/app/fin/task/billing_shared_common.go
@@ -1,6 +1,7 @@
 package task
 
 import (
+	"strconv"
 	"time"
 
 	devSvr "energy-server-mgo/app/admin/service/device"
@@ -40,17 +41,47 @@ func NewSharedCommon() *SharedCommon {
 }
 
 // 计算公摊分摊费用(面积)
-func (common *SharedCommon) calcSharedSquareFee(deviceList []finModel.FinDeviceRecord, squareType string, unpaid float64) []finModel.FinDeviceRecord {
-	var houseIds []uint
-	for _, device := range deviceList {
-		houseIds = append(houseIds, device.HouseId)
+func (common *SharedCommon) calcSharedSquareFee(recordList []finModel.FinDeviceRecord, deviceTypes []string, migrDate string, startDay time.Time, squareType string, unpaid float64) []finModel.FinDeviceRecord {
+	var areaIds []uint
+	for _, device := range recordList {
+		areaIds = append(areaIds, device.AreaId)
 	}
-	houseMap, err := common.srvCommon.ListHouseMap(0, houseIds, nil)
+	houseList, err := common.srvCommon.ListHouseDevice(nil, areaIds, deviceTypes)
 	if err != nil {
 		return nil
 	}
+	migrDay := 0
+	if len(migrDate) > 0 {
+		if val, err := strconv.Atoi(migrDate); err == nil {
+			migrDay = val
+		}
+	}
+
+	var houseIds []uint
+	houseMap := make(map[uint]finReq.HouseInfo)
 	totalArea := float64(0.00)
-	for _, house := range houseMap {
+	for _, house := range houseList {
+		houseId := house.HouseId
+		isVac := true
+		if migrDay > 0 {
+			if house.MoveInTime > 0 && house.MoveOutTime <= 0 {
+				day := time.Unix(house.MoveInTime, 0).Day()
+				if day >= migrDay {
+					isVac = false
+				}
+			} else if house.MoveInTime > 0 && house.MoveOutTime > 0 {
+				day := time.Unix(house.MoveInTime, 0).Day()
+				if startDay.Unix() > house.MoveOutTime {
+					isVac = false
+				} else if day >= migrDay {
+					isVac = false
+				}
+			}
+		}
+		if isVac {
+			houseMap[houseId] = house
+		}
+
 		var area float64
 		switch squareType {
 		case "build":
@@ -67,10 +98,11 @@ func (common *SharedCommon) calcSharedSquareFee(deviceList []finModel.FinDeviceR
 			break
 		}
 		totalArea += area
+		houseIds = append(houseIds, houseId)
 	}
-
-	for idx, device := range deviceList {
-		house, find := houseMap[device.HouseId]
+	var retrecordList []finModel.FinDeviceRecord
+	for _, record := range recordList {
+		house, find := houseMap[record.HouseId]
 		if !find {
 			continue
 		}
@@ -93,29 +125,109 @@ func (common *SharedCommon) calcSharedSquareFee(deviceList []finModel.FinDeviceR
 		if totalArea != 0.00 {
 			price = utils.RoundWithPrecision((area/totalArea)*unpaid, 2)
 		}
-		device.BillAmount = price
-		deviceList[idx] = device
+		record.BillAmount = price
+		retrecordList = append(retrecordList, record)
 	}
-	return deviceList
+	return retrecordList
 }
 
 // 计算公摊分摊费用(房屋)
-func (common *SharedCommon) calcSharedHouseFee(deviceList []finModel.FinDeviceRecord, unpaid float64) []finModel.FinDeviceRecord {
-	totalHouse := len(deviceList)
-	for idx, device := range deviceList {
+func (common *SharedCommon) calcSharedHouseFee(recordList []finModel.FinDeviceRecord, deviceTypes []string, migrDate string, startDay time.Time, unpaid float64) []finModel.FinDeviceRecord {
+	var areaIds []uint
+	for _, device := range recordList {
+		areaIds = append(areaIds, device.AreaId)
+	}
+	srcHouseMap, err := common.srvCommon.ListHouseMap(0, areaIds, 0, nil, nil)
+	if err != nil {
+		return nil
+	}
+	migrDay := 0
+	if len(migrDate) > 0 {
+		if val, err := strconv.Atoi(migrDate); err == nil {
+			migrDay = val
+		}
+	}
+	houseMap := make(map[uint]finReq.HouseInfo)
+	for houseId, house := range srcHouseMap {
+		isVac := true
+		if migrDay > 0 {
+			if house.MoveInTime > 0 && house.MoveOutTime <= 0 {
+				day := time.Unix(house.MoveInTime, 0).Day()
+				if day >= migrDay {
+					isVac = false
+				}
+			} else if house.MoveInTime > 0 && house.MoveOutTime > 0 {
+				day := time.Unix(house.MoveInTime, 0).Day()
+				if startDay.Unix() > house.MoveOutTime {
+					isVac = false
+				} else if day >= migrDay {
+					isVac = false
+				}
+			}
+		}
+		if !isVac {
+			continue
+		}
+		houseMap[houseId] = house
+	}
+	var retrecordList []finModel.FinDeviceRecord
+	totalHouse := len(houseMap)
+	for _, record := range recordList {
+		_, find := houseMap[record.HouseId]
+		if !find {
+			continue
+		}
 		price := utils.RoundWithPrecision((float64(1)/float64(totalHouse))*unpaid, 2)
-		device.BillAmount = price
-		deviceList[idx] = device
+		record.BillAmount = price
+		retrecordList = append(retrecordList, record)
 	}
-	return deviceList
+	return retrecordList
 }
 
 // 计算公摊费用(自定义 水、气)
-func (common *SharedCommon) calcSharedSelfFee(deviceList []finModel.FinDeviceRecord, confItem []interface{}, startDay time.Time, endDay time.Time, unpaid float64) []finModel.FinDeviceRecord {
+func (common *SharedCommon) calcSharedSelfFee(recordList []finModel.FinDeviceRecord, deviceTypes []string, migrDate string, confItem []interface{}, startDay time.Time, endDay time.Time, unpaid float64) []finModel.FinDeviceRecord {
+	var areaIds []uint
+	for _, device := range recordList {
+		areaIds = append(areaIds, device.AreaId)
+	}
+	srtcHouseMap, err := common.srvCommon.ListHouseMap(0, areaIds, 0, nil, nil)
+	if err != nil {
+		return nil
+	}
+	migrDay := 0
+	if len(migrDate) > 0 {
+		if val, err := strconv.Atoi(migrDate); err == nil {
+			migrDay = val
+		}
+	}
+	houseMap := make(map[uint]finReq.HouseInfo)
+	for houseId, house := range srtcHouseMap {
+		isVac := true
+		if migrDay > 0 {
+			if house.MoveInTime > 0 && house.MoveOutTime <= 0 {
+				day := time.Unix(house.MoveInTime, 0).Day()
+				if day >= migrDay {
+					isVac = false
+				}
+			} else if house.MoveInTime > 0 && house.MoveOutTime > 0 {
+				day := time.Unix(house.MoveInTime, 0).Day()
+				if startDay.Unix() > house.MoveOutTime {
+					isVac = false
+				} else if day >= migrDay {
+					isVac = false
+				}
+			}
+		}
+		if !isVac {
+			continue
+		}
+		houseMap[houseId] = house
+	}
+
 	areaAmoutMap := make(map[uint]float64)
 	devNumMap := make(map[uint]int)
 	amountTotal := float64(0.00)
-	for _, device := range deviceList {
+	for _, device := range recordList {
 		amountTotal += device.BillAmount
 		num, find := devNumMap[device.AreaId]
 		if !find {
@@ -133,18 +245,23 @@ func (common *SharedCommon) calcSharedSelfFee(deviceList []finModel.FinDeviceRec
 		amount = amountTotal * item.Value
 		areaAmoutMap[item.AreaId] = amount
 	}
-	for idx, device := range deviceList {
-		amount := areaAmoutMap[device.AreaId]
-		num, _ := devNumMap[device.AreaId]
+	var retrecordList []finModel.FinDeviceRecord
+	for _, record := range recordList {
+		_, find := houseMap[record.HouseId]
+		if !find {
+			continue
+		}
+		amount := areaAmoutMap[record.AreaId]
+		num, _ := devNumMap[record.AreaId]
 		price := utils.RoundWithPrecision((amount/float64(num))*unpaid, 2)
-		device.BillAmount = price
-		deviceList[idx] = device
+		record.BillAmount = price
+		retrecordList = append(retrecordList, record)
 	}
-	return deviceList
+	return recordList
 }
 
 // 计算附加费公摊分摊费用(面积)
-func (common *SharedCommon) calcAttSquareFee(houseList []finReq.HouseInfo, squareType string, unpaid float64) []finModel.FinDeviceRecord {
+func (common *SharedCommon) calcAttSquareFee(houseList []finReq.HouseInfo, deviceTypes []string, isVac string, squareType string, unpaid float64) []finModel.FinDeviceRecord {
 	totalArea := float64(0.00)
 	areaMap := make(map[uint]float64)
 	for _, house := range houseList {
@@ -309,13 +426,13 @@ func (common *SharedCommon) calcApportionSquareFee(ratios []finModel.FinApportio
 		}
 		price := (ratio.HouseArea / area) * unpaid
 		switch roundMethod {
-		case "0":
+		case "round":
 			price = utils.RoundWithPrecision(price, decimalBit)
 			break
-		case "1":
+		case "up":
 			price = utils.RoundUpWithPrecision(price, decimalBit)
 			break
-		case "2":
+		case "trunc":
 			price = utils.DivideAndRound(price, decimalBit)
 			break
 		}
@@ -336,13 +453,13 @@ func (common *SharedCommon) calcApportionRatio(ratios []finModel.FinApportionRat
 		}
 		price := ratio.Ratio * unpaid
 		switch roundMethod {
-		case "0":
+		case "round":
 			price = utils.RoundWithPrecision(price, decimalBit)
 			break
-		case "1":
+		case "up":
 			price = utils.RoundUpWithPrecision(price, decimalBit)
 			break
-		case "2":
+		case "trunc":
 			price = utils.DivideAndRound(price, decimalBit)
 			break
 		}
@@ -361,13 +478,13 @@ func (common *SharedCommon) calcApportionAvg(ratios []finModel.FinApportionRatio
 	for _, ratio := range ratios {
 		price := (ratio.Ratio / float64(total)) * unpaid
 		switch roundMethod {
-		case "0":
+		case "round":
 			price = utils.RoundWithPrecision(price, decimalBit)
 			break
-		case "1":
+		case "up":
 			price = utils.RoundUpWithPrecision(price, decimalBit)
 			break
-		case "2":
+		case "trunc":
 			price = utils.DivideAndRound(price, decimalBit)
 			break
 		}
@@ -390,13 +507,13 @@ func (common *SharedCommon) calcAutoSquareFee(ratios []finModel.FinApportionRati
 		}
 		price := (ratio.HouseArea / area) * unpaid
 		switch roundMethod {
-		case "0":
+		case "round":
 			price = utils.RoundWithPrecision(price, decimalBit)
 			break
-		case "1":
+		case "up":
 			price = utils.RoundUpWithPrecision(price, decimalBit)
 			break
-		case "2":
+		case "trunc":
 			price = utils.DivideAndRound(price, decimalBit)
 			break
 		}
@@ -418,13 +535,13 @@ func (common *SharedCommon) calcAutoRatio(ratios []finModel.FinApportionRatio, b
 		}
 		price := ratio.Ratio * unpaid
 		switch roundMethod {
-		case "0":
+		case "round":
 			price = utils.RoundWithPrecision(price, decimalBit)
 			break
-		case "1":
+		case "up":
 			price = utils.RoundUpWithPrecision(price, decimalBit)
 			break
-		case "2":
+		case "trunc":
 			price = utils.DivideAndRound(price, decimalBit)
 			break
 		}
@@ -444,13 +561,13 @@ func (common *SharedCommon) calcAutoAvg(ratios []finModel.FinApportionRatio, bil
 	for _, ratio := range ratios {
 		price := (ratio.Ratio / float64(total)) * unpaid
 		switch roundMethod {
-		case "0":
+		case "round":
 			price = utils.RoundWithPrecision(price, decimalBit)
 			break
-		case "1":
+		case "up":
 			price = utils.RoundUpWithPrecision(price, decimalBit)
 			break
-		case "2":
+		case "trunc":
 			price = utils.DivideAndRound(price, decimalBit)
 			break
 		}
